/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_CLIENFILIAL                                              */
/* Tabela : CLIENFILIAL                                                       */
/*                                                                            */
/* Criao:                                                                   */
/* 04/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_CLIENFILIAL'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_CLIENFILIAL
GO

CREATE TRIGGER DTULTATU_CLIENFILIAL
ON CLIENFILIAL
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'CLIENFILIAL', CDFILIAL, 'CDFILIAL=' + CDFILIAL + ';'+
                                                'CDCLIENTE='+ CDCLIENTE+ ';', CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) FROM DELETED)
   END
   ELSE BEGIN
      UPDATE CLIENFILIAL
      SET DTULTATUCLIF = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
      FROM INSERTED
      WHERE (ISNULL(CLIENFILIAL.CDFILIAL ,0) = ISNULL(INSERTED.CDFILIAL ,0)) AND
            (ISNULL(CLIENFILIAL.CDCLIENTE,0) = ISNULL(INSERTED.CDCLIENTE,0));

      UPDATE TABEVEND 
      SET DTULTATUTBVE = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
      FROM INSERTED, DELETED, CLIENFILIAL
      WHERE ((ISNULL(DELETED.CDCFILTABPRE,0) <> ISNULL(INSERTED.CDCFILTABPRE,0)) OR
            (ISNULL(DELETED.CDTABEPREC,0)    <> ISNULL(INSERTED.CDTABEPREC,0))) AND
            (TABEVEND.CDFILIAL   = INSERTED.CDCFILTABPRE) AND
            (TABEVEND.CDTABEPREC = INSERTED.CDTABEPREC)

      UPDATE TABEPREC 
      SET DTULTATUTBPR = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
      FROM INSERTED, DELETED, CLIENFILIAL
      WHERE ((ISNULL(DELETED.CDCFILTABPRE,0) <> ISNULL(INSERTED.CDCFILTABPRE,0)) OR
            (ISNULL(DELETED.CDTABEPREC,0)    <> ISNULL(INSERTED.CDTABEPREC,0))) AND
            (TABEPREC.CDFILIAL   = INSERTED.CDCFILTABPRE) AND
            (TABEPREC.CDTABEPREC = INSERTED.CDTABEPREC)

      UPDATE ITEMPRECO
      SET DTULTATUITPR = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
      FROM INSERTED, DELETED, CLIENFILIAL
      WHERE ((ISNULL(DELETED.CDCFILTABPRE,0) <> ISNULL(INSERTED.CDCFILTABPRE,0)) OR
            (ISNULL(DELETED.CDTABEPREC,0)    <> ISNULL(INSERTED.CDTABEPREC,0))) AND
            (ITEMPRECO.CDFILIAL   = INSERTED.CDCFILTABPRE) AND
            (ITEMPRECO.CDTABEPREC = INSERTED.CDTABEPREC)

      UPDATE ITEMPRECODIA 
      SET DTULTATUITPD = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
      FROM INSERTED, DELETED, CLIENFILIAL
      WHERE ((ISNULL(DELETED.CDCFILTABPRE,0) <> ISNULL(INSERTED.CDCFILTABPRE,0)) OR
            (ISNULL(DELETED.CDTABEPREC,0)    <> ISNULL(INSERTED.CDTABEPREC,0))) AND
            (ITEMPRECODIA.CDFILIAL   = INSERTED.CDCFILTABPRE) AND
            (ITEMPRECODIA.CDTABEPREC = INSERTED.CDTABEPREC)


   END;
END;
GO


UPDATE CLIENFILIAL SET DTULTATUCLIF = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) WHERE DTULTATUCLIF IS NULL
GO

IF EXISTS(SELECT * FROM sysobjects O
          WHERE
            o.name = 'DEFAULT_DTULTATUCLIF' and
            type = 'D')
   ALTER TABLE CLIENFILIAL DROP CONSTRAINT DEFAULT_DTULTATUCLIF
GO

ALTER TABLE CLIENFILIAL ADD CONSTRAINT DEFAULT_DTULTATUCLIF
DEFAULT CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
FOR DTULTATUCLIF
GO

-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_CLIENFILIAL','5.07.005';
GO

